#include"KeyBind.hpp"
#include <stdio.h>
#include <Shlwapi.h>

KeyBind::KeyBind()
{
	// .init@C݂ꍇ͂ǂݏo
	if (PathFileExists(INI_FILE_PATH))
	{
		for (size_t i = 0; i < Index::LENGTH; ++i)
			read(i);
	}
	// ݂Ȃꍇ̓ftHg̐ݒgp(ɃftHgݒ.init@C쐬)
	else
	{
		// ftHg̃L[oChZbg
		for (size_t i = 0; i < Index::LENGTH; ++i)
			keyBinds_[i] = DEFAULT_KEY_BINDS[i];

		// ftHg̃L[oCh
		for (size_t i = 0; i < Index::LENGTH; ++i)
			write(i);
	}
}

WORD KeyBind::getNoteNumber(BYTE noteNumber) const
{
	if (noteNumber < MINIMUM_NOTE_NUMBER || MAXIMUM_NOTE_NUMBER < noteNumber)
		return 0;

	return keyBinds_[Index::NOTE_NUMBER + (noteNumber - MINIMUM_NOTE_NUMBER)];
}

WORD KeyBind::getPlayHotKey() const
{
	return keyBinds_[Index::HOTKEY_PLAY];
}

WORD KeyBind::get(size_t index) const
{
	return keyBinds_[index];
}

void KeyBind::set(size_t index, WORD key)
{
	key &= ModifierKey::SHIFT | ModifierKey::CONTROL | ModifierKey::ALTERNATE | 0xff;

	// L[gpς݂Ȃ΃NAĂ܂
	for (size_t i = 0; i < Index::LENGTH; ++i)
	{
		if (keyBinds_[i] == key)
		{
			keyBinds_[i] = 0;
			write(i);
		}
	}

	// VݒZbg
	keyBinds_[index] = key;

	// .init@Cɂ
	write(index);
}

const TCHAR* const KeyBind::INI_KEYS[Index::LENGTH] =
{
	_T("C3"),
	_T("Cs3"),
	_T("D3"),
	_T("Ds3"),
	_T("E3"),
	_T("F3"),
	_T("Fs3"),
	_T("G3"),
	_T("Gs3"),
	_T("A3"),
	_T("As3"),
	_T("B3"),
	_T("C4"),
	_T("Cs4"),
	_T("D4"),
	_T("Ds4"),
	_T("E4"),
	_T("F4"),
	_T("Fs4"),
	_T("G4"),
	_T("Gs4"),
	_T("A4"),
	_T("As4"),
	_T("B4"),
	_T("C5"),
	_T("Cs5"),
	_T("D5"),
	_T("Ds5"),
	_T("E5"),
	_T("F5"),
	_T("Fs5"),
	_T("G5"),
	_T("Gs5"),
	_T("A5"),
	_T("As5"),
	_T("B5"),
	_T("C6"),
	_T("HotkeyPlay"),
};

const WORD KeyBind::DEFAULT_KEY_BINDS[Index::LENGTH] =
{
	'1',
	'2',
	'3',
	'4',
	'5',
	'6',
	'7',
	'8',
	'9',
	'0',
	VK_OEM_MINUS,
	VK_OEM_7,
	'Q',
	'W',
	'E',
	'R',
	'T',
	'Y',
	'U',
	'I',
	'O',
	'P',
	VK_OEM_3,
	VK_OEM_4,
	'A',
	'S',
	'D',
	'F',
	'G',
	'H',
	'J',
	'K',
	'L',
	VK_OEM_PLUS,
	VK_OEM_1,
	VK_OEM_6,
	VK_F11,
};

void KeyBind::read(size_t index)
{
	// .init@C0x0000`6ǂݎ
	// 6 + NULL1ɉ6ȏ̕񌟏o邽߂ɂ1]Ɋmۂ8Ƃ
	TCHAR buffer[8];
	if (GetPrivateProfileString(INI_SECTION, INI_KEYS[index], _T(""), buffer, 8, INI_FILE_PATH) != 6)
	{
		keyBinds_[index] = 0;
		return;
	}

	// 񂩂琮ɕϊ
	TCHAR* end;
	WORD result = static_cast<WORD>(_tcstoul(buffer, &end, 16));
	if (*end == 0)
		keyBinds_[index] = result;
	else
		keyBinds_[index] = 0;
}


void KeyBind::write(size_t index)
{
	// 當ɕϊ
	TCHAR buffer[7];
	_stprintf_s(buffer, 7, _T("0x%04x"), keyBinds_[index]);
	
	// .init@Cɏ
	WritePrivateProfileString(INI_SECTION, INI_KEYS[index], buffer, INI_FILE_PATH);
}

