#pragma once

#include <tchar.h>
#include <Windows.h>
#include "StandardMidiFormat.hpp"
#include "KeyboardSynthesizer.hpp"
#include "MidiSynthesizer.hpp"

/**
 * t
 */
class KeySequencer
{
public:

	/**
	 * RXgN^
	 *
	 * @param keyBind SynthesizerQƂL[oCh
	 */
	KeySequencer(HWND mainWindowHandle, const KeyBind* keyBind);

	/**
	 * fXgN^
	 */
	~KeySequencer();

	/**
	 * tXbhJn
	 */
	void threadStart();

	/**
	 * t@C(SMF)ǂݍ
	 *
	 * @param filepath t@CpX
	 *
	 * @return Ȉꍇ0Aُ킪ꍇ0ȊOԂ
	 *         (StandardMidiFormat::loadFile̖߂lԂ̂ŏڍׂ͂Q)
	 */
	LRESULT loadFile(const TCHAR* filepath);

	/**
	 * t̏ꍇtrueԂ
	 */
	bool isPlaying();

	/**
	 * tJn(߂)
	 */
	void play();

	/**
	 * t~
	 */
	void stop();

	/**
	 * tL[{[h͂Ƃďo͂悤ݒ肷
	 *
	 * ݒς݂̏ꍇ͉Ȃ
	 */
	void setKeyboardOut();

	/**
	 * tMIDIgpŏo͂悤ݒ肷
	 *
	 * ݒς݂̏ꍇ͉Ȃ
	 */
	void setMidiOut();

private:

	/**
	 * XbhItO
	 *
	 * XbhIꍇtrueɂ
	 */
	bool threadClose_;

	/**
	 * ĐtO
	 */
	bool playing_;
	
	/**
	 * CxgǂݎtO
	 *
	 * CxgǂݎĎsҋ@falseACxgς݂true
	 */
	bool nextEvent_;
	
	/**
	 * e|
	 *
	 * l̒}CNbłŕ\
	 */
	DWORD tempo_;

	/**
	 * tJnGetTickCount()Ŏl
	 */
	DWORD playStartMilliseconds_;

	/**
	 * ɏCxgtJn牽}CNbłׂ̒l
	 */
	UINT64 nextEventMicroseconds_;

	/**
	 * CEBhẼnh
	 *
	 * CEBhEɃbZ[W𑗂ۂɎgp
	 */
	HWND mainWindowHandle_;

	/**
	 * Xbhnh
	 */
	HANDLE threadHandle_;

	/**
	 * Xbhp̃VOinh
	 *
	 * ĐɃVOiԂɂăXbh𓮂
	 * ~܂̓EFCgɔVOiԂɂăXbhX[v
	 */
	HANDLE threadActiveEvent_;

	/**
	 * rp̃NeBJZNV
	 */
	CRITICAL_SECTION criticalSection_;

	/**
	 * I𒆂̃VZTCU[
	 *
	 * yɂ𑀍삷
	 */
	Synthesizer* synthesizer_;

	/**
	 * L[{[h͂Ƃďo͂VZTCU[
	 */
	KeyboardSynthesizer keyboardSynthesizer_;

	/**
	 * MIDIgpĉo͂VZTCU[
	 */
	MidiSynthesizer midiSynthesizer_;

	/**
	 * (yf[^(SMF)
	 */
	StandardMidiFormat standardMidiFormat_;

	/**
	 * XbhNɌĂяo֐
	 *
	 * threadRunɏڏ
	 */
	static unsigned __stdcall thread(void* object);

	/**
	 * Xbh{
	 */
	void threadRun();
};
